﻿@namespace VMS.Server.Shared.Components

@inject IBlazorDownloadFileService BlazorDownloadFileService
@inject ISnackbar Snackbar

<InputFile id="@($"file{AttachedFileCategory.Value}")" OnChange="UploadFiles" hidden multiple />

<MudGrid>
    <MudItem md="11">
        <MudTable Items="AttachedFiles" Dense="true" Striped="true" Loading="isLoading">
            <HeaderContent>
                <MudTh>@attachedFilesHeader.GetDisplayName(a => a.AttachedFileCategory)</MudTh>
                <MudTh>@attachedFilesHeader.GetDisplayName(a => a.Name)</MudTh>
                <MudTh>@attachedFilesHeader.GetDisplayName(a => a.Size)</MudTh>
                <MudTh>操作</MudTh>
            </HeaderContent>
            <RowTemplate>
                <MudTd>@context.AttachedFileCategory.DisplayValue</MudTd>
                <MudTd>@context.Name</MudTd>
                <MudTd>@context.Size bytes</MudTd>
                <MudTd>
                    <MudIconButton Color="Color.Secondary" Size="Size.Small"
                                   Icon="@Icons.Material.Filled.Delete" IconSize="Size.Small"
                                   OnClick="@(() => AttachedFiles.Remove(context))" />
                    <MudIconButton Color="Color.Primary" Size="Size.Small"
                                   Icon="@Icons.Material.Filled.Download" IconSize="Size.Small"
                                   @onclick="@(async () => await BlazorDownloadFileService.DownloadFile(context.Name, context.Contents, context.ContentType))" />
                </MudTd>
            </RowTemplate>
        </MudTable>
    </MudItem>
    <MudItem md="1">
        <MudIconButton Size="Size.Small"
                       HtmlTag="label"
                       Color="Color.Primary"
                       Icon="@Icons.Filled.Add"
                       for="@($"file{AttachedFileCategory.Value}")">
        </MudIconButton>
    </MudItem>
</MudGrid>
@code {
    [Parameter]
    public List<AttachedFileEntity> AttachedFiles { get; set; } = new List<AttachedFileEntity>();

    [Parameter]
    public AttachedFileCategory AttachedFileCategory { get; set; }

    private AttachedFileEntity attachedFilesHeader = new();
    private bool isLoading = false;

    private async Task UploadFiles(InputFileChangeEventArgs e)
    {
        try
        {
            isLoading = true;

            long maxAllowedSize = 1024000;
            foreach (var file in e.GetMultipleFiles())
            {
                if (file.Size > 1024000)
                {
                    Snackbar.Add($"アップロード可能なファイルサイズは{(maxAllowedSize / 1000000).ToString()}MBまでです。", Severity.Error);
                    return;
                }

                AttachedFiles.Add(
                    new AttachedFileEntity
                    {
                        Name = file.Name,
                        AttachedFileCategory = AttachedFileCategory,
                        ContentType = file.ContentType,
                        Contents = await file.OpenReadStream(maxAllowedSize: maxAllowedSize).ToBinary(),
                        LastModified = file.LastModified,
                        Size = file.Size,
                    });
            }
        }
        catch (Exception ex)
        {
            Snackbar.Add(ex.Message, Severity.Error);
        }
        finally
        {
            isLoading = false;
        }

    }

}